<?php
class StreamEvent extends YuniccDatabaseRecordClass
{
	public $fill_query = "SELECT * FROM events WHERE `Id` = '%d'";
	public $verify_query = "SELECT * FROM events WHERE `Id` = '%d'";
	public $table_name = "events";
	public $render_template = "element.community.overview.event";
	
	public $prototype = array(
		'numeric' => array(
			'ItemId'		=> "ItemId",
			'Section'		=> "Section",
			'Type'			=> "Type",
			'CommunityId'	=> "ClubId",
			'UserId'		=> "UserId"
		),
		'string' => array(
			'Url'	=> "Url",
			'Title'	=> "Title"
		),
		'timestamp' => array(
			'Date'	=> "Date"
		),
		'user' => array(
			'User'	=> "UserId"
		),
		'community' => array(
			'CommunityId'	=> "ClubId"
		)
	);
	
	public $prototype_render = array(
		'event-string'	=> "RenderString",
		'date'			=> "RenderDate"
	);
	
	public function RenderTemplate()
	{
		$this->sRenderString = $this->Render();
		$this->sRenderDate = $this->RenderTimeAgo("Date");
		return $this->DoRenderInternalTemplate();
	}
	
	public function Render()
	{
		// Takes no arguments.
		// Returns a page-safe string.

		global $locale;

		if(!empty($this->sCommunityId) && !empty($this->sUserId) && !empty($this->sSection) && !empty($this->sType))
		{
			$sUser = new User($this->sUserId);
			
			$sStringAction = "";
			
			switch($this->sSection)
			{
				case YUNICC_EVENT_SECTION_HOME:
					switch($this->sType)
					{
						case YUNICC_EVENT_TYPE_ADD_ITEM:
							$sStringAction = $locale->strings['event-home-added'];
							break;
						case YUNICC_EVENT_TYPE_DELETE_ITEM:
							$sStringAction = $locale->strings['event-home-deleted'];
							break;
						case YUNICC_EVENT_TYPE_EDIT_ITEM:
							$sStringAction = $locale->strings['event-home-edited'];
							break;
						case YUNICC_EVENT_TYPE_MOVE_ITEM:
							$sStringAction = $locale->strings['event-home-reordered'];
							break;
						default:
							throw new Exception("Invalid StreamEvent.Type property.");
							break;
					}
					break;
				case YUNICC_EVENT_SECTION_NEWS:
					switch($this->sType)
					{
						case YUNICC_EVENT_TYPE_ADD_ITEM:
							$sStringAction = $locale->strings['event-news-added'];
							break;
						case YUNICC_EVENT_TYPE_DELETE_ITEM:
							$sStringAction = $locale->strings['event-news-deleted'];
							break;
						case YUNICC_EVENT_TYPE_EDIT_ITEM:
							$sStringAction = $locale->strings['event-news-edited'];
							break;
						case YUNICC_EVENT_TYPE_MOVE_ITEM:
							$sStringAction = $locale->strings['event-news-moved'];
							break;
						case YUNICC_EVENT_TYPE_REPLY_ITEM:
							$sStringAction = $locale->strings['event-news-commented'];
							break;
						case YUNICC_EVENT_TYPE_ADD_CATEGORY:
							$sStringAction = $locale->strings['event-news-category-added'];
							break;
						case YUNICC_EVENT_TYPE_DELETE_CATEGORY:
							$sStringAction = $locale->strings['event-news-category-deleted'];
							break;
						case YUNICC_EVENT_TYPE_EDIT_CATEGORY:
							$sStringAction = $locale->strings['event-news-category-edited'];
							break;
						default:
							throw new Exception("Invalid StreamEvent.Type property.");
							break;
					}
					break;
				case YUNICC_EVENT_SECTION_PICTURES:
					switch($this->sType)
					{
						case YUNICC_EVENT_TYPE_ADD_ITEM:
							$sStringAction = $locale->strings['event-pictures-added'];
							break;
						case YUNICC_EVENT_TYPE_DELETE_ITEM:
							$sStringAction = $locale->strings['event-pictures-deleted'];
							break;
						case YUNICC_EVENT_TYPE_EDIT_ITEM:
							$sStringAction = $locale->strings['event-pictures-edited'];
							break;
						case YUNICC_EVENT_TYPE_MOVE_ITEM:
							$sStringAction = $locale->strings['event-pictures-moved'];
							break;
						case YUNICC_EVENT_TYPE_REPLY_ITEM:
							$sStringAction = $locale->strings['event-pictures-commented'];
							break;
						case YUNICC_EVENT_TYPE_ADD_CATEGORY:
							$sStringAction = $locale->strings['event-pictures-category-added'];
							break;
						case YUNICC_EVENT_TYPE_DELETE_CATEGORY:
							$sStringAction = $locale->strings['event-pictures-category-deleted'];
							break;
						case YUNICC_EVENT_TYPE_EDIT_CATEGORY:
							$sStringAction = $locale->strings['event-pictures-category-edited'];
							break;
						default:
							throw new Exception("Invalid StreamEvent.Type property.");
							break;
					}
					break;
				case YUNICC_EVENT_SECTION_FORUM:
					switch($this->sType)
					{
						case YUNICC_EVENT_TYPE_ADD_ITEM:
							$sStringAction = $locale->strings['event-forum-added'];
							break;
						case YUNICC_EVENT_TYPE_DELETE_ITEM:
							$sStringAction = $locale->strings['event-forum-deleted'];
							break;
						case YUNICC_EVENT_TYPE_EDIT_ITEM:
							$sStringAction = $locale->strings['event-forum-edited'];
							break;
						case YUNICC_EVENT_TYPE_MOVE_ITEM:
							$sStringAction = $locale->strings['event-forum-moved'];
							break;
						case YUNICC_EVENT_TYPE_REPLY_ITEM:
							$sStringAction = $locale->strings['event-forum-commented'];
							break;
						case YUNICC_EVENT_TYPE_ADD_CATEGORY:
							$sStringAction = $locale->strings['event-forum-category-added'];
							break;
						case YUNICC_EVENT_TYPE_DELETE_CATEGORY:
							$sStringAction = $locale->strings['event-forum-category-deleted'];
							break;
						case YUNICC_EVENT_TYPE_EDIT_CATEGORY:
							$sStringAction = $locale->strings['event-forum-category-edited'];
							break;
						default:
							throw new Exception("Invalid StreamEvent.Type property.");
							break;
					}
					break;
				case YUNICC_EVENT_SECTION_FILES:
					switch($this->sType)
					{
						case YUNICC_EVENT_TYPE_ADD_ITEM:
							$sStringAction = $locale->strings['event-files-added'];
							break;
						case YUNICC_EVENT_TYPE_DELETE_ITEM:
							$sStringAction = $locale->strings['event-files-deleted'];
							break;
						case YUNICC_EVENT_TYPE_EDIT_ITEM:
							$sStringAction = $locale->strings['event-files-edited'];
							break;
						case YUNICC_EVENT_TYPE_MOVE_ITEM:
							$sStringAction = $locale->strings['event-files-moved'];
							break;
						case YUNICC_EVENT_TYPE_REPLY_ITEM:
							$sStringAction = $locale->strings['event-files-commented'];
							break;
						case YUNICC_EVENT_TYPE_ADD_CATEGORY:
							$sStringAction = $locale->strings['event-files-category-added'];
							break;
						case YUNICC_EVENT_TYPE_DELETE_CATEGORY:
							$sStringAction = $locale->strings['event-files-category-deleted'];
							break;
						case YUNICC_EVENT_TYPE_EDIT_CATEGORY:
							$sStringAction = $locale->strings['event-files-category-edited'];
							break;
						default:
							throw new Exception("Invalid StreamEvent.Type property.");
							break;
					}
					break;
				case YUNICC_EVENT_SECTION_VIDEO:
					switch($this->sType)
					{
						case YUNICC_EVENT_TYPE_ADD_ITEM:
							$sStringAction = $locale->strings['event-video-added'];
							break;
						case YUNICC_EVENT_TYPE_DELETE_ITEM:
							$sStringAction = $locale->strings['event-video-deleted'];
							break;
						case YUNICC_EVENT_TYPE_EDIT_ITEM:
							$sStringAction = $locale->strings['event-video-edited'];
							break;
						case YUNICC_EVENT_TYPE_MOVE_ITEM:
							$sStringAction = $locale->strings['event-video-moved'];
							break;
						case YUNICC_EVENT_TYPE_REPLY_ITEM:
							$sStringAction = $locale->strings['event-video-commented'];
							break;
						case YUNICC_EVENT_TYPE_ADD_CATEGORY:
							$sStringAction = $locale->strings['event-video-category-added'];
							break;
						case YUNICC_EVENT_TYPE_DELETE_CATEGORY:
							$sStringAction = $locale->strings['event-video-category-deleted'];
							break;
						case YUNICC_EVENT_TYPE_EDIT_CATEGORY:
							$sStringAction = $locale->strings['event-video-category-edited'];
							break;
						default:
							throw new Exception("Invalid StreamEvent.Type property.");
							break;
					}
					break;
				default:
					throw new Exception("Invalid StreamEvent.Section property.");
					break;
			}
			
			if(!empty($this->sUrl))
			{
				$sHref = "<strong><a href=\"#{$this->sUrl}\">{$this->sTitle}</a></strong>";
			}
			else
			{
				$sHref = "<strong>{$this->sTitle}</strong>";
			}
			
			$sString = "<a href=\"#\" onclick=\"lookup_user({$this->sUserId}); return false;\">{$sUser->sDisplayName}</a> " . vsprintf($sStringAction, array(
				$sHref
			));
			
			return $sString;
		}
		else
		{
			throw new Exception("StreamEvent object missing vital properties.");
		}
	}
}
?>
